Index: /pykota/trunk/pykota/storages/mysqlstorage.py
===================================================================
--- /pykota/trunk/pykota/storages/mysqlstorage.py (revision 3294)
+++ /pykota/trunk/pykota/storages/mysqlstorage.py (revision 3308)
@@ -22,6 +22,4 @@
 
 """This module defines a class to access to a MySQL database backend."""
-
-import time
 
 from pykota.errors import PyKotaStorageError
@@ -73,5 +71,4 @@
     def beginTransaction(self) :    
         """Starts a transaction."""
-        self.before = time.time()
         self.cursor.execute("BEGIN;")
         self.tool.logdebug("Transaction begins...")
@@ -80,14 +77,10 @@
         """Commits a transaction."""
         self.database.commit()
-        after = time.time()
         self.tool.logdebug("Transaction committed.")
-        #self.tool.logdebug("Transaction duration : %.4f seconds" % (after - self.before))
         
     def rollbackTransaction(self) :     
         """Rollbacks a transaction."""
         self.database.rollback()
-        after = time.time()
         self.tool.logdebug("Transaction aborted.")
-        #self.tool.logdebug("Transaction duration : %.4f seconds" % (after - self.before))
         
     def doRawSearch(self, query) :
@@ -97,14 +90,11 @@
             query += ';'
         try :
-            before = time.time()
             self.querydebug("QUERY : %s" % query)
             self.cursor.execute(query)
         except self.database.Error, msg :    
-            raise PyKotaStorageError, str(msg)
+            raise PyKotaStorageError, repr(msg)
         else :    
             # This returns a list of lists. Integers are returned as longs.
             result = self.cursor.fetchall()
-            after = time.time()
-            #self.tool.logdebug("Query Duration : %.4f seconds" % (after - before))
             return result
             
@@ -136,13 +126,9 @@
             query += ';'
         try :
-            before = time.time()
             self.querydebug("QUERY : %s" % query)
             self.cursor.execute(query)
         except self.database.Error, msg :    
             self.tool.logdebug("Query failed : %s" % repr(msg))
-            raise PyKotaStorageError, str(msg)
-        else :    
-            after = time.time()
-            #self.tool.logdebug("Query Duration : %.4f seconds" % (after - before))
+            raise PyKotaStorageError, repr(msg)
             
     def doQuote(self, field) :
Index: /pykota/trunk/pykota/storages/pgstorage.py
===================================================================
--- /pykota/trunk/pykota/storages/pgstorage.py (revision 3294)
+++ /pykota/trunk/pykota/storages/pgstorage.py (revision 3308)
@@ -23,5 +23,4 @@
 """This module defines a class to access to a PostgreSQL database backend."""
 
-import time
 from types import StringType
 
@@ -76,5 +75,4 @@
     def beginTransaction(self) :    
         """Starts a transaction."""
-        self.before = time.time()
         self.database.query("BEGIN;")
         self.tool.logdebug("Transaction begins...")
@@ -83,14 +81,10 @@
         """Commits a transaction."""
         self.database.query("COMMIT;")
-        after = time.time()
         self.tool.logdebug("Transaction committed.")
-        #self.tool.logdebug("Transaction duration : %.4f seconds" % (after - self.before))
         
     def rollbackTransaction(self) :     
         """Rollbacks a transaction."""
         self.database.query("ROLLBACK;")
-        after = time.time()
         self.tool.logdebug("Transaction aborted.")
-        #self.tool.logdebug("Transaction duration : %.4f seconds" % (after - self.before))
         
     def doRawSearch(self, query) :
@@ -100,13 +94,8 @@
             query += ';'
         try :
-            before = time.time()
             self.querydebug("QUERY : %s" % query)
-            result = self.database.query(query)
+            return self.database.query(query)
         except PGError, msg :    
-            raise PyKotaStorageError, str(msg)
-        else :    
-            after = time.time()
-            #self.tool.logdebug("Query Duration : %.4f seconds" % (after - before))
-            return result
+            raise PyKotaStorageError, repr(msg)
             
     def doSearch(self, query) :        
@@ -122,14 +111,9 @@
             query += ';'
         try :
-            before = time.time()
             self.querydebug("QUERY : %s" % query)
-            result = self.database.query(query)
+            return self.database.query(query)
         except PGError, msg :    
             self.tool.logdebug("Query failed : %s" % repr(msg))
-            raise PyKotaStorageError, str(msg)
-        else :    
-            after = time.time()
-            #self.tool.logdebug("Query Duration : %.4f seconds" % (after - before))
-            return result
+            raise PyKotaStorageError, repr(msg)
             
     def doQuote(self, field) :
Index: /pykota/trunk/pykota/storages/sqlitestorage.py
===================================================================
--- /pykota/trunk/pykota/storages/sqlitestorage.py (revision 3294)
+++ /pykota/trunk/pykota/storages/sqlitestorage.py (revision 3308)
@@ -22,6 +22,4 @@
 
 """This module defines a class to access to a SQLite database backend."""
-
-import time
 
 from pykota.errors import PyKotaStorageError
@@ -57,5 +55,4 @@
     def beginTransaction(self) :    
         """Starts a transaction."""
-        self.before = time.time()
         self.cursor.execute("BEGIN;")
         self.tool.logdebug("Transaction begins...")
@@ -64,14 +61,10 @@
         """Commits a transaction."""
         self.cursor.execute("COMMIT;")
-        after = time.time()
         self.tool.logdebug("Transaction committed.")
-        #self.tool.logdebug("Transaction duration : %.4f seconds" % (after - self.before))
         
     def rollbackTransaction(self) :     
         """Rollbacks a transaction."""
         self.cursor.execute("ROLLBACK;")
-        after = time.time()
         self.tool.logdebug("Transaction aborted.")
-        #self.tool.logdebug("Transaction duration : %.4f seconds" % (after - self.before))
         
     def doRawSearch(self, query) :
@@ -81,13 +74,10 @@
             query += ';'
         try :
-            before = time.time()
             self.querydebug("QUERY : %s" % query)
             self.cursor.execute(query)
         except self.database.Error, msg :    
-            raise PyKotaStorageError, str(msg)
+            raise PyKotaStorageError, repr(msg)
         else :    
             result = self.cursor.fetchall()
-            after = time.time()
-            #self.tool.logdebug("Query Duration : %.4f seconds" % (after - before))
             return result
             
@@ -118,13 +108,9 @@
             query += ';'
         try :
-            before = time.time()
             self.querydebug("QUERY : %s" % query)
             self.cursor.execute(query)
         except self.database.Error, msg :    
             self.tool.logdebug("Query failed : %s" % repr(msg))
-            raise PyKotaStorageError, str(msg)
-        else :    
-            after = time.time()
-            #self.tool.logdebug("Query Duration : %.4f seconds" % (after - before))
+            raise PyKotaStorageError, repr(msg)
             
     def doQuote(self, field) :