Index: pykota/trunk/bin/warnpykota
===================================================================
--- pykota/trunk/bin/warnpykota (revision 3327)
+++ pykota/trunk/bin/warnpykota (revision 3330)
@@ -22,4 +22,8 @@
 #
 
+"""This command line tool can automatically send periodic email
+notifications to users or groups who have reached the limit of their
+printing quota."""
+        
 import sys
 import os
@@ -32,13 +36,9 @@
 
 import pykota.appinit
-from pykota.utils import *
+from pykota.utils import run
 from pykota.commandline import PyKotaOptionParser
 from pykota.errors import PyKotaCommandLineError
 from pykota.tool import PyKotaTool
 
-"""This command line tool can automatically send periodic email
-notifications to users or groups who have reached the limit of their
-printing quota."""
-        
 class WarnPyKota(PyKotaTool) :        
     """A class for warnpykota."""
Index: pykota/trunk/bin/pkbanner
===================================================================
--- pykota/trunk/bin/pkbanner (revision 3326)
+++ pykota/trunk/bin/pkbanner (revision 3330)
@@ -47,5 +47,5 @@
     
 import pykota.appinit
-from pykota.utils import *
+from pykota.utils import run, loginvalidparam
 from pykota.commandline import PyKotaOptionParser
 
@@ -241,20 +241,20 @@
 
 if __name__ == "__main__" :
-    def checkandset_pagesize(option, opt, value, parser) :
+    def checkandset_pagesize(option, opt, value, optionparser) :
         """Checks and sets the page size."""
         if getPageSize(value) is None :
             loginvalidparam(opt, value, option.default)
-            setattr(parser.values, option.dest, option.default)
+            setattr(optionparser.values, option.dest, option.default)
         else :    
-            setattr(parser.values, option.dest, value)
-        
-    def checkandset_savetoner(option, opt, value, parser) :    
+            setattr(optionparser.values, option.dest, value)
+        
+    def checkandset_savetoner(option, opt, value, optionparser) :    
         """Checks and sets the save toner value."""
         if (value < 0.0) or (value > 99.0) :
             loginvalidparam(opt, value, option.default, \
                             _("Allowed range is (0..99)"))
-            setattr(parser.values, option.dest, option.default)
+            setattr(optionparser.values, option.dest, option.default)
         else :    
-            setattr(parser.values, option.dest, value / 100.0)
+            setattr(optionparser.values, option.dest, value / 100.0)
         
     # TODO : --papertray : to print banners on a different paper (colored for example)
Index: pykota/trunk/bin/autopykota
===================================================================
--- pykota/trunk/bin/autopykota (revision 3325)
+++ pykota/trunk/bin/autopykota (revision 3330)
@@ -23,13 +23,4 @@
 #
 
-import sys
-import os
-
-import pykota.appinit
-from pykota.utils import *
-from pykota.commandline import PyKotaOptionParser
-from pykota.errors import PyKotaToolError
-from pykota.tool import PyKotaTool
-
 """A tool to automate user account creation and initial balance setting.
 
@@ -39,4 +30,13 @@
 OF AN external policy IN pykota.conf
 """
+
+import sys
+import os
+
+import pykota.appinit
+from pykota.utils import run
+from pykota.commandline import PyKotaOptionParser
+from pykota.errors import PyKotaToolError
+from pykota.tool import PyKotaTool
 
 class AutoPyKota(PyKotaTool) :
Index: pykota/trunk/bin/pykosd
===================================================================
--- pykota/trunk/bin/pykosd (revision 3329)
+++ pykota/trunk/bin/pykosd (revision 3330)
@@ -22,4 +22,6 @@
 #
 
+"""An On Screen Display (OSD) monitor for PyKota's end users."""
+
 import sys
 import os
@@ -30,14 +32,12 @@
     import pyosd
 except ImportError :    
-    logerr("Sorry ! You need both xosd and the Python OSD library (pyosd) for this software to work.\n")
+    sys.stderr.write("Sorry ! You need both xosd and the Python OSD library (pyosd) for this software to work.\n")
     sys.exit(-1)
 
 import pykota.appinit
-from pykota.utils import *
+from pykota.utils import run, loginvalidparam
 from pykota.commandline import PyKotaOptionParser
 from pykota.errors import PyKotaToolError, PyKotaCommandLineError
 from pykota.tool import PyKotaTool
-
-"""An On Screen Display (OSD) monitor for PyKota's end users."""
 
 class PyKOSD(PyKotaTool) :
@@ -125,13 +125,13 @@
         
 if __name__ == "__main__" :
-    def checkandset_positiveint(option, opt, value, parser) :    
+    def checkandset_positiveint(option, opt, value, optionparser) :    
         """Checks and sets positive integer values."""
         if value < 0 :
             loginvalidparam(opt, value, option.default)
-            setattr(parser.values, option.dest, option.default)
+            setattr(optionparser.values, option.dest, option.default)
         else :    
-            setattr(parser.values, option.dest, value)
+            setattr(optionparser.values, option.dest, value)
             
-    def checkandset_color(option, opt, value, parser) :    
+    def checkandset_color(option, opt, value, optionparser) :    
         """Checks and sets the color value."""
         if not value.startswith("#") :
@@ -145,10 +145,11 @@
         if (len(value) != 7) or error :
             loginvalidparam(opt, value, option.default)
-            setattr(parser.values, option.dest, option.default)
+            setattr(optionparser.values, option.dest, option.default)
         else :    
-            setattr(parser.values, option.dest, value)
+            setattr(optionparser.values, option.dest, value)
             
     parser = PyKotaOptionParser(description=_("An On Screen Display (OSD) monitor for PyKota's end users."))
     parser.add_option("-c", "--color", "--colour",
+                            type="string",
                             action="callback",
                             callback=checkandset_color,