Index: pykota/trunk/bin/pkinvoice
===================================================================
--- pykota/trunk/bin/pkinvoice (revision 3346)
+++ pykota/trunk/bin/pkinvoice (revision 3360)
@@ -274,5 +274,5 @@
                             dest="logo",
                             default=u"/usr/share/pykota/logos/pykota.jpeg",
-                            help=_("The image to use as a logo. The logo will be drawn at the center top of the page. The default logo is %default"))
+                            help=_("The image to use as a logo. The logo will be drawn at the center top of the page. The default logo is %default."))
     parser.add_option("-p", "--pagesize",
                             type="string",
@@ -281,5 +281,5 @@
                             dest="pagesize",
                             default=u"A4",
-                            help=_("Set the size of the page. Most well known page sizes are recognized, like 'A4' or 'Letter' to name a few. The default page size is %default"))
+                            help=_("Set the size of the page. Most well known page sizes are recognized, like 'A4' or 'Letter' to name a few. The default page size is %default."))
     parser.add_option("-n", "--number",                        
                             dest="number",
@@ -288,5 +288,5 @@
                             callback=checkandset_positiveint,
                             default=1,
-                            help=_("Sets the number of the first invoice. This number will automatically be incremented for each invoice. The default value is %default"))
+                            help=_("Sets the number of the first invoice. This number will automatically be incremented for each invoice. The default value is %default."))
     parser.add_option("-o", "--output",
                             dest="output",
Index: pykota/trunk/bin/pykotme
===================================================================
--- pykota/trunk/bin/pykotme (revision 3358)
+++ pykota/trunk/bin/pykotme (revision 3360)
@@ -117,5 +117,5 @@
 
     parser.add_example("--printer apple file1.ps <file2.pclxl",                            
-                       _("This would show the number of pages needed to print these two files, as well as the cost of printing them to the 'apple' printer."))
+                       _("This would show the number of pages needed to print these two files, as well as the cost of printing them to the 'apple' printer for the user who launched this command."))
     parser.add_example("--user john",
                        _("This would show the number of pages needed to print the content of the standard input, and the cost of printing this on all printers for user 'john'."))
Index: pykota/trunk/bin/repykota
===================================================================
--- pykota/trunk/bin/repykota (revision 3356)
+++ pykota/trunk/bin/repykota (revision 3360)
@@ -92,5 +92,5 @@
     parser.add_option("-i", "--ingroups",
                             dest="ingroups",
-                            help=_("Only reports users who are members of the specified groups. This option is reserved to PyKota administrators."))
+                            help=_("Only report users who are members of the specified groups. This option is reserved to PyKota administrators."))
     parser.add_option("-P", "--printer",
                             dest="printer",
Index: pykota/trunk/bin/pkbanner
===================================================================
--- pykota/trunk/bin/pkbanner (revision 3337)
+++ pykota/trunk/bin/pkbanner (revision 3360)
@@ -234,5 +234,5 @@
                             dest="logo",
                             default=u"/usr/share/pykota/logos/pykota.jpeg",
-                            help=_("The image to use as a logo. The logo will be drawn at the center top of the page. The default logo is %default"))
+                            help=_("The image to use as a logo. The logo will be drawn at the center top of the page. The default logo is %default."))
     parser.add_option("-p", "--pagesize",
                             type="string",
@@ -241,5 +241,5 @@
                             dest="pagesize",
                             default=u"A4",
-                            help=_("Set the size of the page. Most well known page sizes are recognized, like 'A4' or 'Letter' to name a few. The default page size is %default"))
+                            help=_("Set the size of the page. Most well known page sizes are recognized, like 'A4' or 'Letter' to name a few. The default page size is %default."))
     parser.add_option("-s", "--savetoner",
                             type="float",
@@ -252,5 +252,5 @@
                             dest="url",
                             default=u"http://www.pykota.com",
-                            help=_("Set the url to write at the bottom of the banner page. The default url is %default"))
+                            help=_("Set the url to write at the bottom of the banner page. The default url is %default."))
     parser.add_example('--logo="" --savetoner=75',
                        _("This would generate a banner in the default page size, with no logo, and text luminosity would be increased by 75%."))
Index: pykota/trunk/bin/autopykota
===================================================================
--- pykota/trunk/bin/autopykota (revision 3330)
+++ pykota/trunk/bin/autopykota (revision 3360)
@@ -120,8 +120,8 @@
                             dest="initbalance",
                             default=0.0,
-                            help=_("Set the user's initial account balance value. If the user already exists, actual balance is left unchanged. If unset, the default value is %default"))
+                            help=_("Set the user's initial account balance value. If the user already exists, actual balance is left unchanged. If unset, the default value is %default."))
     parser.add_option("-e", "--email",
                             dest="email",
-                            help=_("Set the user's email address"))
+                            help=_("Set the user's email address."))
                             
     parser.add_example('--email="@example.com" --initbalance=10.0',
Index: pykota/trunk/bin/pykosd
===================================================================
--- pykota/trunk/bin/pykosd (revision 3330)
+++ pykota/trunk/bin/pykosd (revision 3360)
@@ -167,5 +167,5 @@
                             dest="font",
                             default=pyosd.default_font,
-                            help=_("Set the font to use. Defaults to %default"))
+                            help=_("Set the font to use. Defaults to %default."))
     parser.add_option("-l", "--loop",
                             type="int",
Index: pykota/trunk/bin/pkrefund
===================================================================
--- pykota/trunk/bin/pkrefund (revision 3347)
+++ pykota/trunk/bin/pkrefund (revision 3360)
@@ -306,5 +306,5 @@
                             dest="logo",
                             default=u"/usr/share/pykota/logos/pykota.jpeg",
-                            help=_("The image to use as a logo. The logo will be drawn at the center top of the page. The default logo is %default"))
+                            help=_("The image to use as a logo. The logo will be drawn at the center top of the page. The default logo is %default."))
     parser.add_option("-p", "--pagesize",
                             type="string",
@@ -313,5 +313,5 @@
                             dest="pagesize",
                             default=u"A4",
-                            help=_("Set the size of the page. Most well known page sizes are recognized, like 'A4' or 'Letter' to name a few. The default page size is %default"))
+                            help=_("Set the size of the page. Most well known page sizes are recognized, like 'A4' or 'Letter' to name a few. The default page size is %default."))
     parser.add_option("-n", "--number",                        
                             dest="number",
@@ -320,5 +320,5 @@
                             callback=checkandset_positiveint,
                             default=1,
-                            help=_("Sets the number of the first receipt. This number will automatically be incremented for each receipt. The default value is %default"))
+                            help=_("Sets the number of the first receipt. This number will automatically be incremented for each receipt. The default value is %default."))
     parser.add_option("-o", "--output",
                             dest="output",